
public class QuickSort<T extends Comparable<? super T>> implements SortInterface<T> {

	@Override
	public void sort(T[] arrayToSort) {
		quickSort(arrayToSort, 0, arrayToSort.length - 1);
	}

	private void quickSort(T[] array, int first, int last) {
		int pivotIndex;
		if (first < last) {
			pivotIndex = partition(array, first, last);
			quickSort(array, first, pivotIndex - 1);
			quickSort(array, pivotIndex + 1, last);
		}
	}

	private void choosePivot(T[] array, int first, int last) {
		// this method could be used to choose different elements to
		// be the pivot. Whatever element gets chosen to be the pivot
		// will be left in array[first].
		//
		// We will use array[first] as our pivot for this demo.
	}

	private int partition(T[] array, int first, int last) {
		T tempItem;

//		choosePivot(array, first, last);
		T pivot = array[first];

		int lastS1 = first;

		for (int firstUnknown = first + 1; firstUnknown <= last; firstUnknown++) {
			if (array[firstUnknown].compareTo(pivot) < 0) {
				lastS1++;
				if (lastS1 != firstUnknown) {
					tempItem = array[firstUnknown];
					array[firstUnknown] = array[lastS1];
					array[lastS1] = tempItem;

					for (int i = 0; i < array.length; i++) {
						System.out.print(array[i] + ", ");
					}
					System.out.println();
				}
			}
		}

		for (int i = 0; i < array.length; i++) {
			System.out.print(array[i] + ", ");
		}
		System.out.println();

		tempItem = array[first];
		array[first] = array[lastS1];
		array[lastS1] = tempItem;

		for (int i = 0; i < array.length; i++) {
			System.out.print(array[i] + ", ");
		}
		System.out.println();

		return lastS1;
	}
}
